/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 02/11/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.MapObjekModulToDepartemen;
import com.portofolio.entity.vo.MapObjekModulToDepartemenId;

import org.springframework.context.annotation.Lazy;

@Lazy
@Repository
public interface MapObjekModulToDepartemenDao
		extends CrudRepository<MapObjekModulToDepartemen, MapObjekModulToDepartemenId> {

	@Cacheable("MapObjekModulToDepartemenDaofindOneBy")
	MapObjekModulToDepartemen findOneByIdKdDepartemenAndIdKdObjekModulAplikasiAndIdKdProfile(String kdDepartemen,
			String kdObjekModulAplikasi, Integer kdProfile);

	@Query(QListAll)
	@Cacheable("MapObjekModulToDepartemenDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, Pageable page);

	@Query(QListAll + " and model.id.kdDepartemen = :kdDepartemen ")
	@Cacheable("MapObjekModulToDepartemenDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,
			@Param("kdDepartemen") String kdDepartemen, Pageable page);

	@Query(QListAll + " and model.id.kdDepartemen = :kdDepartemen")
	@Cacheable("MapObjekModulToDepartemenDaoFindByKode")
	List<Map<String, Object>> findByKode(@Param("kdProfile")Integer kdProfile,@Param("kdDepartemen") String kdDepartemen);
	// /@Param("kdProfile") Integer kdProfile, @Param("kdObjekModulAplikasi") String
	// kdObjekModulAplikasi);

	String QListAll = "select new map(model.id as kode " + ", model.statusEnabled as statusEnabled "
			+ ", model.noRec as noRec " + ", model.version as version )"
			+ " from MapObjekModulToDepartemen model left join model.id id left join model.profile profile where model.id.kdProfile =:kdProfile  and model.statusEnabled = true  ";

	@Modifying
	@Cacheable("setStatusEnabledFalseDao")
	// @Transactional
	@Query("update MapObjekModulToDepartemen m set m.statusEnabled = false where m.id.kdProfile =:kdProfile and m.id.kdDepartemen =:kdDepartemen")
	public void setStatusEnabledFalse(@Param("kdProfile") Integer kdProfile,
			@Param("kdDepartemen") String kdDepartemen);

	@Cacheable("countIdKdObjekModulAplikasiByIdKdObjekModulAplikasiAndIdKdProfileDao")
	Long countIdKdDepartemenByIdKdDepartemenAndIdKdProfile(String kdDepartemen, Integer kdProfile);
}
